<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id$
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Mobile
 * @copyright  Copyright (c) 2012 VEC
 */

class Mobile_MapController extends Zend_Controller_Action
{

    public function indexAction()
    {
        $settings = Zend_Registry::get('settings');
        $userId = Zend_Controller_Action_HelperBroker::getStaticHelper('userId')->direct();
        
        $layerSettingsTable = new Giscuit_Db_Table_LayerSettings();

        if(! isset($settings->offlineTimestamp)) {
            $settings->offlineTimestamp = time();
        }
        
        //Set layout
        $this->_helper->layout->getLayoutInstance()->disableInflector();
        $this->_helper->layout->getLayoutInstance()->setLayout(
            'map' . DIR_SEP . 'layout' . GT_SCRIPT_EXT 
        );
                
        if(! empty($userId)) {
             //Reset settings
            $settings = Zend_Registry::get('settings');
            $settings->historyId = NULL;
            
            //FIXME:
            if(! empty($_SERVER['HTTP_REFERER'])) {
                $settings->editingActive = false;
            }
            
            $settings->historyDateBegin = NULL;
            $settings->historyDateEnd = NULL;
            //$settings->editingHistory = array();
            $settings->querybuilder = NULL;
            
            $layers = $layerSettingsTable->getPrivateItems();
            $layersRecords = $layers['layers'];
            $layers = array_merge($layers['layers'], $layers['categories']);
            
            $layersMenu = new Giscuit_Menu_Mobile_Privatelayers();
            $layersMenu->buildNestedArray($layers);
            
            $offlineMenu = new Giscuit_Menu_Mobile_Offline();
            $offlineMenu->buildNestedArray($layers);
            
            $this->view->layersMenu = $layersMenu;
            $this->view->layersRecords = $layersRecords;
            $this->view->offlineMenu = $offlineMenu;
        } else {
            $layers = $layerSettingsTable->getPublicItems();
            $layersRecords = $layers['layers'];
                        
            $layers = array_merge($layers['layers'], $layers['baseLayers']);
            
            $layersMenu = new Giscuit_Menu_Mobile_Publiclayers();
            $layersMenu->buildNestedArray($layers);
            
            $this->view->layersMenu = $layersMenu;
            $this->view->layersRecords = $layers;
        }
        
        //
        $this->view->editLayer = '';
                
        if(! empty($userId)) {
            $users = new Giscuit_Db_Table_Users();
            $userData = $users->getItems(array(
                'whereId' => $userId
            ))->current();
                    
            $layersTable = new Giscuit_Db_Table_Layers();
            $editResult = $layersTable->getEditLayer();
                        
            if($editResult['editgeom'] == false && $editResult['editattr'] == false) {
            } else {
                $this->view->editLayer = $editResult['settings']['class'];
            }
            
            $this->view->guest = 'f';
        } else {
           $userData = new stdClass();
           $userData->snap = 'f';
           $userData->tooltip = 't';
           $userData->touch_offset = 0;
           $this->view->guest = 't';
        }
        
        $this->view->userData = $userData;    
        
        /*
        //Expires
        $this->getResponse()->setHeader('Expires', 'Sat, 26 Jul 1997 05:00:00 GMT', true);
        $this->getResponse()->setHeader('Cache-Control', '', true);
        */
    }
    
}