<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id$
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Mobile
 * @copyright  Copyright (c) 2012 VEC
 */

class Mobile_MenuController extends Zend_Controller_Action
{
    public function indexAction()
    {
        $config = Zend_Registry::get('config');
        $locale = Zend_Registry::get('Zend_Translate')->getLocale();
        
        $menuTable = new Giscuit_Db_Table_Menu();
        $menuData = $menuTable->getItems(array(
            'withTitle' => true ,
            'whereActive' => 't' ,
        ));
        
        $menu = new Giscuit_Menu_Mobile_Navigation();
        $menu->buildNestedArray($menuData);
        
        //Title
        if(isset($config->ows->$locale->ows_title)) {
            $this->view->owsTitle = $config->ows->$locale->ows_title;
        } else {
            $this->view->owsTitle = '';
        }
        
        $this->view->menu = $menu;
    }

    public function browseAction ()
    {
        $request = $this->getRequest();
        $id = intval($request->getUserParam('id'));
        
        $menuTable = new Giscuit_Db_Table_Menu();
        $rows = array_values($menuTable->getItems(array(
            'whereId' => $id , 
            'whereActive' => 't' ,
            'withTitle' => true , 
            'withText' => true , 
            'withTags' => true
        )));

        if(! count($rows)) {
            throw new Giscuit_Exception('Invalid article id (' . $id . ')');
        }        
        
        $row = $rows[0];
        $this->view->row = $row;
        
    }
}