<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: LayerDefaults.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Db_Table
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Giscuit_Db_Table_Abstract
 */
require_once 'Giscuit/Db/Table/Abstract.php';

/**
 * Class for layers defaults table 
 *
 * @category   Giscuit
 * @package    Giscuit_Db_Table
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Db_Table_LayerDefaults extends Giscuit_Db_Table_Abstract
{

    /**
     * Table name
     * 
     * @var string
     */
    protected $_name = 'layer_defaults';

    /**
     * Table primary key name
     * 
     * @var string
     */
    protected $_primary = 'id';
    
    /**
     * Replace old label fields with new ones
     * 
     * @param string $oldName Old label name
     * @param string $newName New label name
     * @return void
     */
    public function cleanupLabelFields ($oldName, $newName)
    {
        if (empty($newName)) {
            $value = '';
        } else {
            $value = ',' . $newName;
        }
        
        $data = array(
            'label_fields' => new Zend_Db_Expr("replace(label_fields, ',$oldName', '$value')")
        );
        $this->update($data, NULL);
        
        $data = array(
            'label_fields' => new Zend_Db_Expr("replace(label_fields, '$oldName', '$newName')")
        );
        $this->update($data, NULL);
    
    }

}
