<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: History.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Giscuit_Form_Abstract
 */
require_once 'Giscuit/Form/Abstract.php';

/**
 * Form class changing history date range 
 * 
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Form_History extends Giscuit_Form_Abstract
{
    /**
     * Initialize
     *
     * @return void
     */
    public function init ()
    {
        //From
        $this->addElement('text', 'dateBegin', array(
            'filters' => array(
                'StringTrim'
            ) , 
            'validators' => array(
                array(
                    'Date' , 
                    false , 
                    array(
                        GT_DATE_STYLE_ZEND
                    )
                )
            ) ,
            'required' => false , 
            'label' => 'dateBegin' , 
            'attribs' => array(
                'id' => 'gtHistorymanageDateBeginId'
            )
        ));
        
        //To
        $this->addElement('text', 'dateEnd', array(
            'filters' => array(
                'StringTrim'
            ) , 
            'validators' => array(
                array(
                    'Date' , 
                    false , 
                    array(
                        GT_DATE_STYLE_ZEND
                    )
                )
            ) , 
            'required' => false , 
            'label' => 'dateEnd' , 
            'attribs' => array(
                'id' => 'gtHistorymanageDateEndId'
            )
        ));
        
        //Submit
        $this->addElement('button', 'submit_button', array(
            'required' => false , 
            'ignore' => true , 
            'label' => 'submit' , 
            'attribs' => array(
                'id' => 'gtHistorymanageSubmit'
            ) , 
            'decorators' => array(
                'ViewHelper'
            )
        ));
        
        //Reset
        $this->addElement('button', 'reset_button', array(
            'required' => false , 
            'ignore' => true , 
            'label' => 'reset' , 
            'attribs' => array(
                'id' => 'gtHistorymanageReset'
            ) , 
            'decorators' => array(
                'ViewHelper'
            )
        ));
    
    }
}