<?php

/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Privatelayers.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Menu
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * Class for hierarchic private layers menu
 * 
 * @category   Giscuit
 * @package    Giscuit_Menu
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Menu_Privatelayers extends Giscuit_Menu
{
    /**
     * Build a menu using Yahoo User Interface javascript template
     * 
     * @param array $data
     * @return string
     */
    public function buildMenu (array &$data)
    {
        $js = '[';
        foreach ($data as $row) {
            $js .= $this->_buildRow($row);
            if (! empty($row['child'])) {
                $js .= sprintf(',submenu:{id:YAHOO.util.Dom.generateId(), itemdata: %s}', $this->buildMenu($row['child']));
            }
            $js .= "},";
        }
        if(strlen($js) > 1) {
            $js = substr($js, 0, - 1);
        }
        $js .= ']';
        
        return $js;
    }
    
    /**
     * Build menu element
     * 
     * @param array $row Element
     * @return string
     */
    protected function _buildRow ($row)
    {
        $text = "{";
        $text .= "text: '{$row['name']}' ";
        $text .= ", value: {path: '{$row['path']}'} ";
        
        return $text;
    }
    
    /**
     * Formats menu elements
     * 
     * @param array $child Element of the menu
     * @return array
     */
    protected function _parse ($child)
    {
        $child['name'] = htmlspecialchars($child['name'], ENT_QUOTES);
        
        return $child;
    }
    
    
}