<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: ControllerTestCase.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Test
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Zend_Test_PHPUnit_ControllerTestCase
 */
require_once 'Zend/Test/PHPUnit/ControllerTestCase.php';

/**
 * Functional testing scaffold for MVC applications
 *
 * @category   Giscuit
 * @package    Giscuit_Test
 * @copyright  Copyright (c) 2012 VEC
 */
abstract class Giscuit_Test_PHPUnit_ControllerTestCase extends Zend_Test_PHPUnit_ControllerTestCase
{
    /**
     * Test user credentials
     * 
     * @var array
     */
    protected $_user = array(
        'account' => 'test@giscuit.com' , 
        'password' => '123456'
    );
    
    /**
     * Test user language
     * 
     * @var string
     */
    protected $_language = 'en';

    /**
     * Set up MVC app
     *
     * @return void
     */
    public function setUp ()
    {
        parent::setUp();
        setupGiscuitFrontController(false);
    }
    
    /**
     * 
     * Enter description here ...
     */
    public function tearDown()
    {
        $this->reset();
        parent::tearDown();
    }
    
    /**
     * 
     * Enter description here ...
     */
    public function clear() {
        $this->resetRequest();
        $this->resetResponse();

        $this->request->setPost(array());
        $this->request->setQuery(array());
                
        Zend_Layout::resetMvcInstance();
        Zend_Controller_Action_HelperBroker::resetHelpers();
        //$this->frontController->resetInstance();
        Zend_Session::$_unitTestEnabled = true;
        
    }

    /**
     * Authenticate test user
     * 
     * @return void
     */
    protected function _testLoginActionSuccess ()
    {
        //
        $this->request->setMethod('POST')->setPost($this->_user);
        $this->dispatch('/' . $this->_language . '/default/auth');
        $this->assertObjectHasAttribute('id', Zend_Auth::getInstance()->getIdentity());
        
        $this->clear();
        
        //
        $this->dispatch('/' . $this->_language . '/admin/users/index');
        $this->assertResponseCode(200);
        
        $this->clear();
    }
}
