<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: IdAvailable.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Validate
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * Check if $value matches current user's password
 * 
 * @category   Giscuit
 * @package    Giscuit_Validate
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Validate_IdAvailable extends Zend_Validate_Abstract
{

    const ID_NOT_AVAILABLE = 'IdNotAvailable';

    /**
     * Validation failure message template definitions
     *
     * @var array
     */
    protected $_messageTemplates = array(
        self::ID_NOT_AVAILABLE => "This ID is not available"
    );

    /**
     * Defined by Zend_Validate_Interface
     * 
     * Returns true if and only if $value matches current user's password
     * 
     * @param string $value
     * @return boolean
     */
    public function isValid ($value)
    {
        $usersTable = new Giscuit_Db_Table_Users();
        $tableName = $usersTable->info('name');
        $row = $usersTable->fetchRow($tableName . ".account = '$value'");
        
        if (empty($row)) {
            return true;
        } else {
            $this->_error(self::ID_NOT_AVAILABLE);
            return false;
        }
       
    }
}