<?php
/**
 * Giscuit
 *
 * @category   Giscuit
 * @package    Giscuit_Validate
 * @copyright  Copyright (c) 2010 Giscuit
 */

/**
 * Check for a psql.exe file on a given $path
 * 
 * @category   Giscuit
 * @package    Giscuit_Validate
 * @copyright  Copyright (c) 2010 Giscuit
 */
class Giscuit_Validate_PsqlExists extends Zend_Validate_Abstract
{

    const WRONG_PSQL_PATH = 'wrongPsqlPath';

    /**
     * Validation failure message template definitions
     *
     * @var array
     */
    protected $_messageTemplates = array(
        self::WRONG_PSQL_PATH => "Wrong Postgresql bin path"
    );

    /**
     * Defined by Zend_Validate_Interface
     * 
     * Returns true if there is a psql.exe file on the given $path
     * 
     * @param string $path
     * @return boolean
     */
    public function isValid ($path)
    {
        $existsPsql = file_exists($path . DIR_SEP . 'psql.exe');
        $existsShp2Pgsql = file_exists($path . DIR_SEP . 'shp2pgsql.exe');
        
        if ($existsPsql == false || $existsShp2Pgsql == false) {
            $this->_error(self::WRONG_PSQL_PATH);
            return false;
        } else {
            return true;
        }
    }
}

?>