<?php

/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Xml.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Validate
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * Xml validator
 * 
 * @category   Giscuit
 * @package    Giscuit_Validate
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Validate_Xml extends Zend_Validate_Abstract
{
	const INVALID_XML = 'invalidXml';
	
	/**
	 * Validation failure message template definitions
	 *
	 * @var array
	 */
	protected $_messageTemplates = array(
		self::INVALID_XML => "Invalid XML"
	);
	
	
    /**
     * Defined by Zend_Validate_Interface
     *
     * Returns true if and only if $value is xml
     *
     * @param  string $value
     * @return boolean
     */
    public function isValid ($value)
    {
        $valueString = (string) $value;
        $this->_setValue($valueString);
        
        try {
        	$configContent = new Zend_Config_Xml($valueString);
        } catch(Zend_Config_Exception $e) {
        	$this->_messageTemplates['invalidXml'] = $e->getMessage(); 
        	$this->_error(self::INVALID_XML);
        	
        	return false;
        }
        
        return true;
    }

}
