<?php

//Patch information
$currentVersion = '1.2.7';
$updateVersion = '1.3.0';
$downloadsUrl = 'http://downloads.giscuit.com';

//Defines
require_once '..' . DIRECTORY_SEPARATOR . 'Defines.php';
if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
    define('GT_MS_PATH', realpath(GT_APP_PATH . DIR_SEP . '..' . DIR_SEP . '..' . DIR_SEP . '..'));    
    } else {
    define('GT_MS_PATH', NULL);
}

//Errors
error_reporting(E_ALL | E_STRICT);
ini_set('display_startup_errors', 1);
ini_set('display_errors', 1);
ini_set('log_errors', 0);

//Include_path
$paths = array(
    realpath(GT_LIBRARY_PATH) , 
    get_include_path()
);
set_include_path(implode(PATH_SEPARATOR, $paths));

//Loader
require_once 'Zend/Loader/Autoloader.php';
$loader = Zend_Loader_Autoloader::getInstance();
$loader->registerNamespace('Giscuit_');

//Translate
$translate = new Zend_Translate('tmx', GT_LANGUAGES_PATH . DIR_SEP . 'admin.en.tmx', 'en');
Zend_Registry::set('Zend_Translate', $translate);

//Config
$config = new Zend_Config_Xml(GT_CONFIG_PATH . DIR_SEP . 'config.xml', null, array(
    'skipExtends' => true , 
    'allowModifications' => true
));

//
$view = new Zend_View();
$view->type = 'patch';
$view->httpPath = $config->production->httpPath;
$view->licenseType = $config->production->licenses->type;


//
$view->params = '';

//Install 
if (isset($_GET['install']) && $_GET['install'] == 't') {
	$view->install = 't';
	
	if ($config->production->version == $updateVersion) {
    	$view->bd = "System was already updated to this version";
    	
	} else if ($config->production->version != $currentVersion) {
    	$view->bd = "This patch is for version {$currentVersion}";
	    
	} else {
	    //Initialize database
	    Giscuit_Controller_Plugin_Init::parseDbParams($config->production->database);
	    $db = Zend_Db::factory($config->production->database);
	    $db->getConnection();
	    Zend_Db_Table_Abstract::setDefaultAdapter($db);
	    
	    try {
	    	//Patch process BEGIN
	    	
	        //Update languages
	        updateLanguages(array(
	            'en' => array(
	                'adminData' => 'Manage data',
	                'firstNFieldsDisplayed' => 'Only first %1$s fields are displayed',
	                'loadQuery' => 'Load query' ,
        	        'load' => 'Load' ,
        	        'queryName' => 'Query name' ,
        	        'saveQuery' => 'Save query' ,
        	        'enableGeolocationTool' => 'Enable geolocation tool' 
	            ),
	            'ro' => array(
	                'adminData' => 'Gestionarea datelor',
	                'firstNFieldsDisplayed' => 'Numai primele %1$s câmpuri sunt afişate' ,
	                'loadQuery' => 'Încară interogarea' ,
        	        'load' => 'Încară' ,
        	        'queryName' => 'Denumirea interogării' ,
        	        'saveQuery' => 'Salvează interogarea' ,
        	        'enableGeolocationTool' => 'Activează instrumentul geolocaţiei' 
	            ),
	            'ru' => array(
	                'adminData' => 'Управление данными',
	                'firstNFieldsDisplayed' => 'Только первые %1$s полей показано' ,
	                'loadQuery' => 'Загрузить запрос' ,
        	        'load' => 'Загрузить' ,
        	        'queryName' => 'Название запроса' ,
        	        'saveQuery' => 'Сохранить запрос' ,
        	        'enableGeolocationTool' => 'Активировать инструмент геолокации' 
	            )
	        ));
	        
	        //Update rules
	        $defaultSchema = $config->production->database->schema;
	        
	        $patchSql = array(
	        	"INSERT INTO {$defaultSchema}.roles VALUES ('admin_users', '', 8)",
	        	"INSERT INTO {$defaultSchema}.roles VALUES ('admin_news', '', 9)",
	        	"INSERT INTO {$defaultSchema}.roles VALUES ('admin_data', '', 10)",
	            "INSERT INTO {$defaultSchema}.roles VALUES ('admin_data_share', '', 11)",
	        
	        	"INSERT INTO {$defaultSchema}.rules VALUES (9, 'admin_users', 'admin_menu', '', 'menu')",
				"INSERT INTO {$defaultSchema}.rules VALUES (10, 'admin_news', 'admin_menu', '', 'menu')",
	        	"INSERT INTO {$defaultSchema}.rules VALUES (11, 'admin', 'admin_layer', '', 'layer')",
	            "INSERT INTO {$defaultSchema}.rules VALUES (12, 'admin_data_share', 'admin_data_share', '', '')",
	        	"INSERT INTO {$defaultSchema}.rules VALUES (13, 'admin', 'admin', '', '')",
				"INSERT INTO {$defaultSchema}.rules VALUES (14, 'admin_data', 'admin_data', '', '')",
	        	"INSERT INTO {$defaultSchema}.rules VALUES (315, 'registered', 'admin_home_controller', '', 'controller')",
	        	"INSERT INTO {$defaultSchema}.rules VALUES (316, 'admin_users', 'admin_users_controller', '', 'controller')",
				"INSERT INTO {$defaultSchema}.rules VALUES (317, 'admin_news', 'admin_news_controller', '', 'controller')",
	        	"INSERT INTO {$defaultSchema}.rules VALUES (318, 'admin_data', 'admin_database_controller', '', 'controller')",
	        
                "INSERT INTO {$defaultSchema}.rules VALUES (319, 'admin_data', 'admin_layers_controller', 'index', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (320, 'admin_data', 'admin_layers_controller', 'edit', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (321, 'admin_data', 'admin_layers_controller', 'add', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (322, 'admin_data', 'admin_layers_controller', 'delete', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (323, 'admin_data', 'admin_layers_controller', 'classesget', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (324, 'admin_data', 'admin_layers_controller', 'classesadd', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (325, 'admin_data', 'admin_layers_controller', 'classesupdate', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (326, 'admin_data', 'admin_layers_controller', 'classesclassify', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (327, 'admin_data', 'admin_layers_controller', 'classesdelete', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (328, 'admin_data', 'admin_layers_controller', 'classesmove', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (329, 'admin_data', 'admin_layers_controller', 'stylesget', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (330, 'admin_data', 'admin_layers_controller', 'stylesadd', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (331, 'admin_data', 'admin_layers_controller', 'stylesupdate', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (332, 'admin_data', 'admin_layers_controller', 'stylesdelete', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (333, 'admin_data', 'admin_layers_controller', 'stylesmove', 'controller')",
	        
	            "INSERT INTO {$defaultSchema}.rules VALUES (334, 'admin_data', 'admin_layers_controller', 'fieldsget', 'controller')",
	        	"INSERT INTO {$defaultSchema}.rules VALUES (335, 'admin_data', 'admin_layers_controller', 'fieldsupdate', 'controller')",
	        	"INSERT INTO {$defaultSchema}.rules VALUES (336, 'admin_data', 'admin_layers_controller', 'fieldsmove', 'controller')",

                "INSERT INTO {$defaultSchema}.rules VALUES (337, 'admin_data', 'admin_layers_controller', 'orderget', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (338, 'admin_data', 'admin_layers_controller', 'ordersave', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (339, 'admin_data', 'admin_layers_controller', 'owsget', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (340, 'admin_data', 'admin_layers_controller', 'owsedit', 'controller')",
                "INSERT INTO {$defaultSchema}.rules VALUES (341, 'admin_data', 'admin_layers_controller', 'proxy', 'controller')",
	        	"INSERT INTO {$defaultSchema}.rules VALUES (342, 'admin_data', 'admin_acl_controller', 'getprivileges', 'controller')",
	        	"INSERT INTO {$defaultSchema}.rules VALUES (343, 'admin_data', 'admin_layers_controller', 'permissionsget', 'controller')",
				"INSERT INTO {$defaultSchema}.rules VALUES (344, 'admin_data', 'admin_layers_controller', 'permissionsedit', 'controller')",
				"INSERT INTO {$defaultSchema}.rules VALUES (345, 'admin_data', 'admin_layers_controller', 'permissionsgetusers', 'controller')",

	        	"UPDATE {$defaultSchema}.rules SET \"role\"='registered' WHERE resource='admin_checkupdate_controller'",
	        
	        	"UPDATE {$defaultSchema}.menu SET url='/<language>/admin/home' WHERE url='/<language>/admin/users'",
	        
	            "CREATE TABLE {$defaultSchema}.layer_permissions (
                    id integer NOT NULL,
                    user_id integer,
                    view_ids pg_catalog.text,
                    editgeom_ids pg_catalog.text,
                    editattr_ids pg_catalog.text,
                    ows_ids pg_catalog.text
                )",
	            "ALTER TABLE ONLY {$defaultSchema}.layer_permissions ADD CONSTRAINT layer_permissions_pkey PRIMARY KEY (id)",
	            "ALTER TABLE ONLY {$defaultSchema}.layer_permissions ADD CONSTRAINT layer_permissions_id_fkey FOREIGN KEY (id) REFERENCES {$defaultSchema}.layers(id) ON DELETE CASCADE",
	        
	            "ALTER TABLE {$defaultSchema}.users ADD COLUMN tables text",
	        
	            "CREATE TABLE {$defaultSchema}.querybuilder_queries (
                    id serial NOT NULL,
                    user_id integer,
                    query pg_catalog.text,
                    \"name\" pg_catalog.text,
                    date timestamp with time zone
                )",
	            "ALTER TABLE ONLY {$defaultSchema}.querybuilder_queries ADD CONSTRAINT querybuilder_queries_pkey PRIMARY KEY (id)"
	        	
	        );
	        
	        foreach ($patchSql as $value) {
	            $db->query($value);
	        }
	        
	        //Update config
	        $config->production->userIdentityExpr = "users.fname || ' ' || users.lname";
	        $config->production->maxFieldsAmount = 50;
	    	
	        //Patch process END
	        $config->production->version = $updateVersion;
	        
	        //
	        require_once GT_MODULES_PATH . DIR_SEP . 'admin' . DIR_SEP . 'controllers' . DIR_SEP . 'GenconfController.php';
	        Admin_GenconfController::escapeConfig($config->production);
	        
	        //
	        $writer = new Zend_Config_Writer_Xml(array(
	            'config' => $config , 
	            'filename' => GT_CONFIG_PATH . DIR_SEP . 'config.xml'
	        ));
	        $writer->write();
	        
	        //License
	        if(isset($_POST['agreement_text']) && $_POST['agreement_text']) {
	            file_put_contents(GT_APP_PATH . DIR_SEP . "LICENSE.txt", $_POST['agreement_text']);
	        }
	        
	        //Clear cache
	        $frontendOptions = array(
	            'lifetime' => 3600 , 
	            'automatic_serialization' => true
	        );
	        if(extension_loaded('apc')) {
	            $backendOptions = array(
	            );
	            $backend = 'Apc';            
	        } else {
	            $backendOptions = array(
	                'cache_dir' => GT_TMP_PATH
	            );
	            $backend = 'File';
	        }
	        $cache = Zend_Cache::factory('Core', $backend, $frontendOptions, $backendOptions);
	        $cache->clean(Zend_Cache::CLEANING_MODE_ALL);
	    
	        $view->bd = "Giscuit was successfully patched to version " . $updateVersion;
	    
	    } catch (Exception $e) {
	        $db->rollBack();
	        $view->bd = $e->getMessage();
		}
	}
} else {
	$view->install = 'f';
	
    $contentView = new Zend_View();
    $contentView->type = 'patch';
    $contentView->addScriptPath(GT_MODULES_PATH . DIR_SEP . 'default' . DIR_SEP . 
        'views' . DIR_SEP . 'scripts' . DIR_SEP . 'generic');
    
    $view->bd = $contentView->render('installLicenseAgreement' . GT_SCRIPT_EXT);
    
}

$view->addScriptPath(GT_LAYOUTS_PATH);
echo $view->render('install' . GT_SCRIPT_EXT);

function updateLanguages(array $messages = array()) {
    foreach ($messages as $languageKey => $languageValue) {
        
        $languageFile = GT_LANGUAGES_PATH . DIR_SEP . 'default.' . $languageKey . '.tmx';
        if(! file_exists($languageFile)) {
            continue;       
        }
        
        $translate = new Zend_Translate('tmx', $languageFile, $languageKey);
    
        $newMessages = array_merge($translate->getMessages(), $languageValue);
        $newTmx = Giscuit_Controller_Plugin_Abstract::arrayToTmx($languageKey, $newMessages);
        
        file_put_contents(GT_LANGUAGES_PATH . DIR_SEP . 'default.' . $languageKey . '.tmx', $newTmx);
    }    
}