<?php
/**
 * Proxy
 * 
 * This script can be used to circumvent javascript's security requirements
 * which prevent a URL from an external web site being called.
 * Redirects the request http://YOUR_DOMAIN/proxy.php?url=http://SOME_URL
 * to http://SOME_URL 
 *  
 * @category   Giscuit
 * @copyright  Copyright (c) 2012 VEC
 */

//Errors
ini_set('display_startup_errors', 1);
ini_set('display_errors', 1);
ini_set('log_errors', 0);

//Allowed domain names
$allowedDomains = array(
    //'earthquake.usgs.gov',
	'iap.md'
);

//Leave blank if your server does not use a proxy for internet access
$host = '';
$port = 8080;

//Leave blank if proxy does not require authorization
$username = '';
$password = '';

//Method and header
$defaultOpts['http'] = array(
	'method' => $_SERVER['REQUEST_METHOD'],
	'header' => "Accept-language: en\r\n"
);

//Content-type
if(isset($_SERVER['CONTENT_TYPE'])) {
	$defaultOpts['http']['header'] .= "Content-type: {$_SERVER['CONTENT_TYPE']}\r\n";
}

//Proxy
if(! empty($host) && ! empty($port)) {
    $defaultOpts['http'] = array_merge($defaultOpts['http'], array(
        'http' => array(
            'proxy' => "tcp://{$host}:{$port}",
            'request_fulluri' => true ,
        )
    ));
                
    if (! empty($username) && ! empty($password)) {
        $credentials = base64_encode($username . ':' . $password);
        $defaultOpts['http']['header'] .= "Proxy-Authorization: Basic " . $credentials . "\r\n";
    }
}

//Content
$content = file_get_contents('php://input');
if($content) {
    $defaultOpts['http']['content'] = $content;
    $defaultOpts['http']['header'] .= 'Content-Length: ' . strlen($content) . "\r\n";
}

//
stream_context_set_default($defaultOpts);

//
$url = $_GET['url'];
$urlParts = parse_url($url);

//Validate
if(empty($urlParts['scheme']) || empty($urlParts['host'])) {
    die("Invalid url ({$url})");
}
if(! in_array($urlParts['host'], $allowedDomains)) {
    die("Invalid host ({$urlParts['host']})");
}

if (! $fp = fopen($url, 'r')) {
    die("Unable to open URL ({$url})");
}

//Get content type
$contentType = '';
$meta = stream_get_meta_data($fp);
for ($i = 0; isset($meta['wrapper_data'][$i]); $i++) {
    if (strstr(strtolower($meta['wrapper_data'][$i]), 'content-type')) {
        $contentType = substr($meta['wrapper_data'][$i], 14);
        break;
    }
}
if(! empty($contentType)) {
    header('Content-type: ' . $contentType);
}

//Get contents
echo stream_get_contents($fp);

fclose($fp);