/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 * @version    $Id: Home.js 2536 2012-04-12 21:23:20Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 */
Giscuit.Map.prototype.gtEventListeners.push({
    'draw': function() {
        gt.control.home = new Giscuit.Control.Home();
    }
});

/**
 * Class: Giscuit.Control.Home
 * 
 *  Inherits from:
 *   - <Giscuit.Control>
 */
Giscuit.Control.Home = OpenLayers.Class(Giscuit.Control, {
    
    active: false,
    
    button: null,
    
    initialize: function (options) {
        Giscuit.Control.prototype.initialize.apply(this, [options]);
        
        this.addHomeButton();
    },
    
    activate: function () {
        var activated = Giscuit.Control.prototype.activate.call(this);
               
        return activated;
    },

    deactivate: function () {
        var deactivated = Giscuit.Control.prototype.deactivate.call(this);
                        
        return deactivated;
    },
    
    addHomeButton: function() {
        $(document).ready(Giscuit.Util.bind(function() {
            $("#gtMapControls").append('<div>'
                + '<div class="ui-bar ui-bar-c" id="gtHomeButton">'
                + '<div class="gtMapControlsElImage" style="background-position: -512px 50%;"></div>'
                + '<div class="gtMapControlsElText">' + gt.translate._('homeButton') + '</div>'
                + '</div></div>');
                        
            $("#gtHomeButton").unbind(gt.config.clickEvt).bind(gt.config.clickEvt, Giscuit.Util.bind(function() {
                window.location = gt.config.httpMobilePath + '/menu';
                
                return false;
            }, this));
    
            //Change offline button order
            if($("#gtOfflineButton").length == 1) {
                var btnHtml = $("#gtOfflineButton").parent().html();
                $("#gtOfflineButton").parent().remove();
                $("#gtLegendButton").parent().after('<div>' + btnHtml + '</div>');
            }
            
            gt.init.layout.renderMapControls();
        
        }, this));
    },

    deleteHomeButton: function() {
        $('#gtHomeButton').parent().remove();
        $("#gtHomeButton").unbind();
        
        gt.init.layout.renderMapControls();
    },
    
    CLASS_NAME: "Giscuit.Control.Home"
});