Giscuit.Mobile.Map.prototype.gtEventListeners.push({
    'draw': function() {
        gt.control.incidents = new Giscuit.Mobile.Control.Incidents();
    }
});

/**
 * Namespace: Giscuit.Mobile.Control.Incidents
 */
Giscuit.Mobile.Control.Incidents = OpenLayers.Class(Giscuit.Control, {
    
    features: [],
    
    ignoredFields: ['gid', 'image_id', 'image_name', 'image_url', 'category_color', 'geometry'],
    
    currentActiveValue: 1,
    
    currentCategoryValue: 0,
    
    drawControl: null,
    
    selected: null,
    
    newIncident: null,
    
    //allowManageIncidents: false,
    
    lastSelected: null,
    
    initialize: function (options) {
        Giscuit.Control.prototype.initialize.apply(this, [options]);
        
        //Display page, add button and events
        $(document).ready(Giscuit.Util.bind(function() {
            
            //Create page for displaying results
            var html = 
            '<div data-role="page" id="gtIncidents" data-dom-cache="true" data-url="gtIncidents">' +
            '<div data-role="header">' +
                '<h1>' + gt.translate._('reports') + '</h1>' +
                '<a href="#gtMap" data-icon="map" data-direction="reverse" class="ui-btn-right jqm-home">' +
                    gt.translate._('map') + 
                '</a>' + 
            '</div>' +
             
            '<div data-role="content">' + 
                '<select id="gtIncidentsAddButton" name="gtIncidentsAddButton" data-native-menu="false">' +
                    '<option>' + gt.translate._('addReport') + '</option>' +
                    '<option value="1">' + gt.translate._('myCurrentLocation') + '</option>' +
                    '<option value="2">' + gt.translate._('point') + '</option>' +
                    '<option value="3">' + gt.translate._('line') + '</option>' +
                    '<option value="4">' + gt.translate._('polygon') + '</option>' +
                '</select>' + 
                '<fieldset data-role="controlgroup" data-type="horizontal" class="gtIncidentsHorizontalFieldset">' +
                    '<select id="gtIncidentsActiveSelect" name="gtIncidentsActiveSelect">' +
                        '<option value="0">' + gt.translate._('all') + '</option>' +
                        '<option value="1" selected>' + gt.translate._('open') + '</option>' +
                        '<option value="2">' + gt.translate._('closed') + '</option>' +
                    '</select>' + 
                    '<select id="gtIncidentsCategorySelect" name="gtIncidentsCategorySelect">' +
                        '<option value="0">' + gt.translate._('allCategories') + '</option>' +
                    '</select>' + 
                '</fieldset>' +
                '<br>' +
                '<ul id="gtIncidentsList" data-role="listview">' +
                '</ul>' +
            '</div>' +        
            '</div>';
                
            $.mobile.pageContainer.append(html);
            $('#gtIncidents').page();
            
            $('.gtIncidentsHorizontalFieldset').children().each(function (el) {
                $(this).css('marginTop', '10px');
                $(this).width('50%');
                $(this).children().width('100%');
            });
            
            //Create page for incidents form
            var formPage = 
            '<div data-role="page" id="gtIncidentsAddPage" data-dom-cache="true" data-url="gtIncidentsAddPage">' +
            '<div data-role="header">' +
                '<h1>' + gt.translate._('addReport') + '</h1>' +
                '<a href="#gtMap" data-icon="map" data-direction="reverse" class="ui-btn-right jqm-home">' +
                    gt.translate._('map') + 
                '</a>' + 
            '</div>' +
                 
            '<div data-role="content">' +                 
            '</div>';
            
            $.mobile.pageContainer.append(formPage);
            $('#gtIncidentsAddPage').page();
                
            //Append control button
            var buttonHtml = '<div>'
                + '<div class="ui-bar ui-bar-c" id="gtIncidentsButton">'
                + '<div class="gtMapControlsElImage" style="background-position: -768px 50%;"></div>'
                + '<div class="gtMapControlsElText">' + gt.translate._('reports') + '</div>'
                + '</div></div>';
            $('#gtLegendButton').parent().after(buttonHtml);

            var withGeolocation = false;
            $("#gtIncidentsAddButton-button").unbind(gt.config.clickEvt).bind(gt.config.clickEvt, Giscuit.Util.bind(function(evt) {
                 $("#gtIncidentsAddButton").selectmenu('open');
                
                if ($('.gtLocationToggle').length == 0) {
                    var toggleEl = $('#gtIncidentsAddButton-menu').children().first().next();
                    if (toggleEl.hasClass('ui-btn-active')) {
                        toggleEl.removeClass('ui-btn-active');
                    }
                    toggleEl.attr('data-icon', 'checkbox-off');
                    toggleEl.children().children().first().after('<span class="ui-icon ui-icon-shadow ui-icon-checkbox-off gtLocationToggle">&nbsp;</span>');
                    toggleEl.unbind(gt.config.clickEvt).bind(gt.config.clickEvt, Giscuit.Util.bind(function(evt) {
                        if ($('.gtLocationToggle').hasClass('ui-icon-checkbox-off')) {
                            $('.gtLocationToggle').removeClass('ui-icon-checkbox-off');
                            $('.gtLocationToggle').addClass('ui-icon-checkbox-on');
                            withGeolocation = true;
                        } else {
                            $('.gtLocationToggle').removeClass('ui-icon-checkbox-on');
                            $('.gtLocationToggle').addClass('ui-icon-checkbox-off');
                            withGeolocation = false;
                        }
                        
                        return false;
                    }, this));
                }
                
                return false;
            }, this));
            
            $("#gtIncidentsAddButton").change(Giscuit.Util.bind(function(evt) {
                var option = evt.target.options[evt.target.selectedIndex].value;

                if (withGeolocation) {
                    gt.control.geolocation.start();
                } 
                withGeolocation = false;

                if (this.drawControl != null) {
                    this.drawControl.destroy();
                    this.drawControl = null;
                }
                
                if (option == 2) {
                    this.drawControl = new OpenLayers.Control.DrawFeature(gt.layer.vector, OpenLayers.Handler.Point, {
                        callbacks: {
                            "done": OpenLayers.Function.bind(this.addIncident, this)
                        }
                    });
                } else if (option == 3) {
                    this.drawControl = new OpenLayers.Control.DrawFeature(gt.layer.vector, OpenLayers.Handler.Path, {
                        callbacks: {
                            "done": OpenLayers.Function.bind(this.addIncident, this)
                        }
                    });
                } else if (option == 4) {
                    this.drawControl = new OpenLayers.Control.DrawFeature(gt.layer.vector, OpenLayers.Handler.Polygon, {
                        callbacks: {
                            "done": OpenLayers.Function.bind(this.addIncident, this)
                        }
                    });
                }

                gt.map.addControl(this.drawControl);
                this.drawControl.activate();
                
                $.mobile.changePage($('#gtMap'));
                //Giscuit.Util.jqmMessage(gt.translate._('drawPointHelp'));
                
                $("#gtIncidentsButton").addClass('ui-btn-active');
                
                evt.target.selectedIndex = 0;
                $("#gtIncidentsAddButton").selectmenu('refresh', true);
            }, this));
            
            $("#gtIncidentsActiveSelect").change(Giscuit.Util.bind(function(evt) {
                this.currentActiveValue = evt.target.options[evt.target.selectedIndex].value;

                gt.layer.Incidents.load(null, this.currentActiveValue, this.currentCategoryValue);
            }, this));
            
            $("#gtIncidentsCategorySelect").change(Giscuit.Util.bind(function(evt) {
                this.currentCategoryValue = evt.target.options[evt.target.selectedIndex].value;

                gt.layer.Incidents.load(null, this.currentActiveValue, this.currentCategoryValue);
            }, this));
            
            //Toggle activate/deactivate
            $("#gtIncidentsButton").unbind(gt.config.safeClickEvt).bind(gt.config.safeClickEvt, Giscuit.Util.bind(function() {
                if($("#gtIncidentsButton").hasClass('ui-btn-active')) {
                    this.deactivate();
                } else {
                    $.mobile.showPageLoadingMsg();
                    this.activate();
                }
                
                return false;
            }, this));
            
            //Online
            gt.control.offline.events.register('online', this, function() {
                $("#gtHomeButton").parent().before(buttonHtml);
                
                $("#gtIncidentsButton").unbind(gt.config.safeClickEvt).bind(gt.config.safeClickEvt, Giscuit.Util.bind(function() {
                    if($("#gtIncidentsButton").hasClass('ui-btn-active')) {
                        this.deactivate();
                    } else {
                        $.mobile.showPageLoadingMsg();
                        this.activate();
                    }
                    
                    return false;
                }, this));
            });
                
            //Offline
            gt.control.offline.events.register('offline', this, function() {
                $('#gtIncidentsButton').parent().remove();
            });
            
            if(! gt.control.offline.isOnline) {
                $('#gtIncidentsButton').parent().remove();
            } else {
                $.ajax({
                    'type': 'GET',
                    'url': gt.config.httpToolPath + '/incidents/getcategories',
                    'success': this.populateCategories,
                    'error': Giscuit.Util.jqmAjaxError ,
                    'dataType': 'json' ,
                    'context': this
                });
            }
        }, this));
    },
    
    activate: function () {
        var activated = Giscuit.Control.prototype.activate.call(this);
        
        //Hide map controls
        $("#gtMapControls").css('display', 'none');
        $("#gtToggleControlsButton").css('bottom', '5px').removeClass('ui-btn-active');
        
        $.mobile.hidePageLoadingMsg();

        if (gt.layer.Incidents.visibility == false) {
            var layerId = gt.control.layers.getLayerIdByClassName('Incidents');
            gt.control.layers.setSettings('view', layerId, true);
        }
        
        //Show results page
        $.mobile.changePage($('#gtIncidents'), {
            'changeHash': true
        });
        
        return activated;
    },
    
    deactivate: function () {
        var deactivated = Giscuit.Control.prototype.deactivate.call(this);
        
        if (deactivated == true) {
            if(this.lastSelected) {
                this.lastSelected.layer.drawFeature(this.lastSelected, 'default');
            }
        }
        
        if ($("#gtIncidentsButton").hasClass('ui-btn-active')) {
            $("#gtIncidentsButton").removeClass('ui-btn-active');
        }

        if (this.drawControl && this.drawControl.active) {
            this.drawControl.deactivate();
        }
        
        return deactivated;
    },
    
    getFeaturesFromLayer: function() {
        this.features.length = 0;

        for (var i = 0; i < gt.layer.Incidents.features.length; i++) {
            var tempObj = jQuery.extend(true, {}, gt.layer.Incidents.features[i].attributes);
            tempObj.geometry = gt.layer.Incidents.features[i].geometry;

            this.features.push(tempObj);
        }

        this.buildIncidentsList();
    },
    
    buildIncidentsList: function () {
        var html = '';
        
        for (var a = 0; a < this.features.length; a++) {
            var item = this.features[a];
            html += '<li>' + item.title + '<ul>';
            
            for (var attr in item) {
                //Filter the unnecessary fields
                if (jQuery.inArray(attr, this.ignoredFields) == -1) {
                    //Format "active" field
                    if (attr == 'active') {
                        //Show or hide "active" field
                        if (this.currentActiveValue != 0) {
                            continue;
                        } else if (item[attr] == 't') {
                            html += '<li>' + gt.translate._('status') + ': ' + gt.translate._('open') + '</li>';
                        } else {
                            html += '<li>' + gt.translate._('status') + ': ' + gt.translate._('closed') + '</li>';
                        }
                    //Format "image" field
                    } else if (attr == 'image') {
                        html += '<li>' + item[attr] + '</li>';
                    } else {
                        html += '<li>' + gt.translate._(attr) + ': ' + item[attr] + '</li>';
                    }
                }
            }
            html += '<li data-geometry="' + item.geometry + '"><button type="button" class="gtIncidentsShowOnMapButton" style="z-index: 1100;">' + gt.translate._('showResultsOnMap') + '</button></li>';

            if (gt.pluginParams.incidentsSetstatusIsAllowed) {
                if (item['active'] == 't') {
                    var closeOpenText = gt.translate._('close');
                } else {
                    var closeOpenText = gt.translate._('open');
                }
                html += '<fieldset class="gtIncidentsHorizontalFieldset" data-role="controlgroup" data-type="horizontal" data-gid="' + item.gid + '" style="padding-left: 15px; padding-right: 15px;">';
                    html += '<button type="button" class="gtIncidentsCloseButton" style="z-index: 1100;">' + closeOpenText + '</button>';
                    html += '<button type="button" class="gtIncidentsDeleteButton" style="z-index: 1100;">' + gt.translate._('delete') + '</button>';
                html += '</fieldset>';
            }
            
            html += '</ul></li>';
        }
        
        $("div[data-role='page']").each(function (index, value){
            var el = $(value);
            var page = 'gtIncidents&ui-page=';
            if(el.jqmData('url').substr(0, page.length) == page) {
                el.remove();
            }           
        });
        
        $("#gtIncidentsList").html(html);
        $("#gtIncidentsList").listview('refresh');
        
        $('.gtIncidentsHorizontalFieldset').children().each(function (el) {
            $(this).width('50%');
        });
        
        //Show object on map
        $('.gtIncidentsShowOnMapButton').unbind(gt.config.clickEvt).bind(gt.config.clickEvt, this, function(evt) {
            var geometryStr = $(this.parentNode.parentNode).jqmData('geometry');

            if(typeof(geometryStr) != 'undefined') {
                var geometry = OpenLayers.Geometry.fromWKT(geometryStr);
                
                //
                if(evt.data.lastSelected) {
                    evt.data.lastSelected.layer.drawFeature(evt.data.lastSelected, 'default');
                }

                evt.data.lastSelected = gt.layer.Incidents.getFeatureBy('geometry', geometry.toString());
                evt.data.lastSelected.layer.drawFeature(evt.data.lastSelected, 'select');  

                gt.map.zoomToExtent(geometry.getBounds());
                if (geometry instanceof OpenLayers.Geometry.Point) {
                    gt.map.zoomTo(gt.config.resolutions.length - 3);
                }
            }
            
            $.mobile.changePage($('#gtMap'), {
                'changeHash': true
            });
            
            return false;
        });
        
        //Delete object
        $('.gtIncidentsDeleteButton').unbind(gt.config.clickEvt).bind(gt.config.clickEvt, this, function(evt) {
            $.mobile.showPageLoadingMsg();
            this.disabled = true;
            
            var gid = $(this.parentNode.parentNode).jqmData('gid');

            url = gt.config.httpToolPath + '/incidents/delete/gid/' + gid;

            $.ajax({
                'type': 'POST',
                'url': url,
                'success': function(data) {
                    $.mobile.hidePageLoadingMsg();
                    $.mobile.changePage($('#gtMap'), {
                        'changeHash': true
                    });
                    gt.layer.Incidents.load(null, this.currentActiveValue, this.currentCategoryValue);
                },
                'error': Giscuit.Util.jqmAjaxError ,
                'dataType': 'json' ,
                'context': this
            });

            return false;
        });
        
        //Close/open object
        $('.gtIncidentsCloseButton').unbind(gt.config.clickEvt).bind(gt.config.clickEvt, this, function(evt) {
            $.mobile.showPageLoadingMsg();
            this.disabled = true;
            
            var gid = $(this.parentNode.parentNode).jqmData('gid');

            url = gt.config.httpToolPath + '/incidents/setstatus/gid/' + gid;

            $.ajax({
                'type': 'POST',
                'url': url,
                'success': function(data) {
                    $.mobile.hidePageLoadingMsg();
                    $.mobile.changePage($('#gtMap'), {
                        'changeHash': true
                    });
                    gt.layer.Incidents.load(null, this.currentActiveValue, this.currentCategoryValue);
                },
                'error': Giscuit.Util.jqmAjaxError ,
                'dataType': 'json' ,
                'context': this
            });

            return false;
        });
    },
    
    addIncident: function (geom) {
        //Check if valid Polygon
        if(geom instanceof OpenLayers.Geometry.Polygon && geom.getVertices().length < 3) {
            return;
        }
        
        //Check if valid Line
        if(geom instanceof OpenLayers.Geometry.LineString && geom.getVertices().length == 2
            && geom.components[0].distanceTo(geom.components[1]) == 0) {
            return;
        }
        
        $.mobile.showPageLoadingMsg();

        if (geom instanceof OpenLayers.Geometry.Point && gt.control.geolocation.point != null) {
            var pixels = gt.map.getLayerPxFromLonLat(new OpenLayers.LonLat(geom.x, geom.y));
            var topLeft = gt.map.getLonLatFromViewPortPx({
                'x': pixels.x - gt.map.snapTolerance,
                'y': pixels.y - gt.map.snapTolerance
            });
            var bottomRight = gt.map.getLonLatFromViewPortPx({
                'x': pixels.x + gt.map.snapTolerance,
                'y': pixels.y + gt.map.snapTolerance
            });
            
            var bounds = new OpenLayers.Bounds();
            bounds.extend(topLeft);
            bounds.extend(bottomRight);
            
            var boundsGeometry = bounds.toGeometry();
    
            if (boundsGeometry.intersects(gt.control.geolocation.point.geometry)) {
                this.newIncident = new OpenLayers.Feature.Vector(gt.control.geolocation.point.geometry.clone());
            } else {
                this.newIncident = new OpenLayers.Feature.Vector(geom);
            }
        } else {
            this.newIncident = new OpenLayers.Feature.Vector(geom);
        }

        gt.layer.Incidents.addFeatures([this.newIncident]);
        
        this.drawControl.deactivate();
        $("#gtIncidentsButton").removeClass('ui-btn-active');
        
        var url = gt.config.httpToolPath + '/incidents/add';
        
        $.ajax({
            'type': 'GET',
            'url': url,
            'success': this.getIncidentsFormSuccess,
            'error': Giscuit.Util.jqmAjaxError ,
            'dataType': 'json' ,
            'context': this
        });
    },
    
    getIncidentsFormSuccess: function(data) {
        var content = $("#gtIncidentsAddPage > div[data-role='content']");
        content.html(data.form).trigger('create');
        
        $.mobile.changePage($('#gtIncidentsAddPage'), {
            'changeHash': true
        });
        
        $('.ui-loader').each(function (evt) {
            $(this).css('display', 'none');
        });
        
        var submited = false;
        //Submit
        $('#gtIncidentsSubmit').unbind(gt.config.clickEvt).bind(gt.config.clickEvt, this, function(evt) {
            $(this).button('disable');
            submited = true;
            evt.data.incidentsSubmit();
           
            return false;
        });
        
        //Remove geometry if not submited
        $('#gtIncidentsAddPage').die().live('pagehide', this, function(evt, ui) {
            if (! submited) {
                gt.layer.Incidents.removeFeatures([evt.data.newIncident]);
                evt.data.newIncident = null;
            }
        });
        
        //Cancel
        $('#gtIncidentsBack').unbind(gt.config.clickEvt).bind(gt.config.clickEvt, this, function(evt) {
            $.mobile.changePage($('#gtMap'), {
                'changeHash': true
            });
            
            return false;
        });
        
        
        $.mobile.hidePageLoadingMsg();
    }, 
    
    incidentsSubmit: function() {
        var url = gt.config.httpToolPath + '/incidents/add';
        var postData = {'geometry': this.newIncident.geometry.toString()};
        
        $('#gtIncidentsForm').ajaxSubmit({
            'type': 'POST',
            'url': url,
            'data': postData,
            'success': this.incidentSubmitSuccess,
            'error': Giscuit.Util.jqmAjaxError ,
            'dataType': 'json',
            'context': this
        }); 
    },
    
    incidentSubmitSuccess: function(data) {
        if (data.form) {
            this.getIncidentsFormSuccess(data);
        } else {
            $.mobile.changePage($('#gtMap'), {
                'changeHash': true
            });
            if (this.selected != null ) {
                gt.map.globalSelectControl.unselect(this.selected);
                this.selected = null;
            }
            gt.layer.Incidents.load(null, this.currentActiveValue, this.currentCategoryValue);
        }
    },
    
    populateCategories: function (data) {
        var options = $("#gtIncidentsCategorySelect");
        
        for (var category in data.records) {
            options.append($("<option />").val(data.records[category].id).text(data.records[category][data.currentKey]));
        }

        $("#gtIncidentsCategorySelect").selectmenu("refresh", true);
    }, 

    CLASS_NAME: "Giscuit.Mobile.Control.Incidents"
});
