/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 *
 *
 * @version    $Id: Info.js 1555 2011-08-02 15:41:37Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 *
 */

Giscuit.Map.prototype.gtEventListeners.push({
    'draw': function() {
        gt.control.search = new Giscuit.Mobile.Control.Search();
    }
});

/**
 * Class: Giscuit.Mobile.Control.Search
 * 
 *  Inherits from:
 *   - <Giscuit.Control>
 */
Giscuit.Mobile.Control.Search = OpenLayers.Class(Giscuit.Control, {
    
    selected: null,
    
    selectControl: null,
    
    limit: 100,
    
    initialize: function (options) {
        //Add info page
        $(document).ready(Giscuit.Util.bind(function() {
            $("#gtMapControls").append('<div>'
                + '<div class="ui-bar ui-bar-c" id="gtSearchButton">'
                + '<div class="gtMapControlsElImage" style="background-position: -192px 50%;"></div>'
                + '<div class="gtMapControlsElText">' + gt.translate._('search') + '</div>'
                + '</div></div>');
            
            var html = 
            '<div data-role="page" id="gtSearch" data-dom-cache="true" data-url="gtSearch">' +
            '<div data-role="header">' +
                '<h1>' + gt.translate._('search') + '</h1>' +
                '<a href="#gtMap" data-icon="map" data-direction="reverse" class="ui-btn-right jqm-home">' +
                    gt.translate._('map') + 
                '</a>' + 
            '</div>' +
         
            '<div data-role="content">' + 
            '</div>' +    

            '</div>';
            
            $.mobile.pageContainer.append(html);
            $('#gtSearch').page();

            // 
            $("#gtSearchButton").bind(gt.config.clickEvt, this, function(evt) {
                evt.data.activate();
                return false;
            });
            
        }, this));
        
        Giscuit.Control.prototype.initialize.apply(this, [options]);
    },
    
    activate: function () {
        var activated = Giscuit.Control.prototype.activate.call(this);
               
        //
        //$("#gtSearchButton").addClass('ui-btn-active');
        
        //Hide map controls
        $("#gtMapControls").css('display', 'none');
        $("#gtToggleControlsButton").css('bottom', '5px').removeClass('ui-btn-active');
        
        $.mobile.showPageLoadingMsg();
        
        if (gt.control.offline.isOnline) {
            var url = gt.config.httpMobilePath + '/search/index';
    
            $.ajax({
                'type': 'GET',
                'url': url,
                'success': this.get,
                'error': Giscuit.Util.jqmAjaxError ,
                'dataType': 'json' ,
                'context': this
            });
        } else {
            var layerType = Giscuit.Util.getStorageObject('gtLayerType');
            
            //Select control
            var offlineLayersArr = [];
            for (var i = 0; i < gt.control.layers.records.length; i++) {
                if (gt.control.layers.records[i].offline == true && 
                    layerType['layer_' + gt.control.layers.records[i].id] == 'vector') {
                    
                    offlineLayersArr.push(gt.layer[gt.control.layers.records[i]['class']]);
                }
            }
            this.selectControl = new OpenLayers.Control.SelectFeature(offlineLayersArr);
            gt.map.addControl(this.selectControl);
            this.selectControl.activate();
            this.selectControl.handlers.feature.deactivate();
            
            var data = {};
            data.form = this.buildOfflineForm();
            this.get(data);
        }
        
        return activated;
    },

    deactivate: function () {
        var deactivated = Giscuit.Control.prototype.deactivate.call(this);
        
        //
        //$("#gtSearchButton").removeClass('ui-btn-active');
        
        //Destroy features
        if(this.selected != null) {
            gt.layer.vector.destroyFeatures([this.selected]);
            this.selected = null;
        } else if(this.selectControl != null) {
            this.selectControl.unselectAll();
            this.selectControl.destroy();
            this.selectControl = null;
        }
        
        return deactivated;
    },
    
    filterByVisibility: function() {
        //Get visible layers
        var visibleLayers = [];
        if(gt.config.guest == 't') {
            $('.ui-btn-active').find('.gtLayersMenuName').each(function(i, el) {
                var layerId = $(el).data('layer-id');
                var layerSettings = gt.control.layers.getLayerRecordById(layerId);
                visibleLayers = visibleLayers.concat(layerSettings.ids);
            });
        } else {
            for(i=0; i < gt.control.layers.records.length; i++) {
                var layer = gt.control.layers.records[i];
            
                if(layer.view) {
                    visibleLayers.push(layer.id);
                }
            }
        }
        
        //Clear layer
        $('#gtSearchLayer').children().each(function(i, el) {
            if(! Giscuit.Util.inArray(visibleLayers, $(el).val())) {
                $(el).remove();
            }
        });
        $('#gtSearchLayer').selectmenu('refresh');
        
        //Clear field
        $('#gtSearchField').children().remove();
        $('#gtSearchField').selectmenu('refresh');
        
        //
        if(! $('#gtSearchLayer').children().length) {
            $('#gtSearchSubmit').button('disable');
        } else {
            this.selectTable();
            $('#gtSearchSubmit').button('enable');
        }
    },
    
    get: function (data) {
        //Render
        var content = $("#gtSearch > div[data-role='content']")
            .html(data.form).trigger('create');

        //Add javascript layers
        for(i=0; i < gt.control.layers.records.length; i++) {
            var layerSettings = gt.control.layers.records[i];
            
            if(gt.control.offline.isOnline && 
                layerSettings.js_layer && 
                typeof(gt.layer[layerSettings['class']].features) != 'undefined') {
                
                $('#gtSearchLayer').append($('<option>').val(layerSettings.id).text(layerSettings.name));
            }    
        }
        
        this.filterByVisibility();
        
        $.mobile.changePage($('#gtSearch'), {
            'changeHash': true
        });
        
        //Update layer fields
        $('#gtSearchLayer').die().live('change', Giscuit.Util.bind(function () {
            this.selectTable();
        }, this));
        
        //Set search request
        $('#gtSearchSubmit').bind(gt.config.clickEvt, Giscuit.Util.bind(function(evt) {
        	$('#gtSearchSubmit').button('disable');
        	
            $.mobile.showPageLoadingMsg();
            
            var layerSettings = gt.control.layers.getLayerRecordById($('#gtSearchLayer').val());
            
            if (gt.control.offline.isOnline && ! layerSettings.js_layer) {
                var url = gt.config.httpMobilePath + '/search/index';
    
                if($('#gtSearchWhere-bbox').is(':checked')) {
                    $('#gtSearchWhere-bbox').val(gt.map.getExtent().toBBOX());
                }
                
                $.ajax({
                    'type': 'POST',
                    'url': url,
                    'data': $('#gtSearchForm').serialize(),
                    'success': this.set,
                    'error': Giscuit.Util.jqmAjaxError ,
                    'dataType': 'json' ,
                    'context': this
                });
            } else {
                var layer = gt.layer[layerSettings['class']];
                var currentBounds = gt.map.getExtent();
                
                var field = $('#gtSearchField').val();
                var fieldValue = $('#gtSearchText').val().toString().toLowerCase();
                var searchEverywhere = $('#gtSearchWhere-everywhere')[0].checked;
                
                //Get default field
                if(layerSettings.default_field) {
                    var defaultField = layerSettings.default_field;
                } else if(typeof(layer.defaultField) != 'undefined') {
                    var defaultField = layer.defaultField;
                } else {
                    for(var defaultField in layer.features[0].attributes) {
                        break;
                    }
                }
                
                //Get search scale
                var searchScale = null;
                if(layerSettings.search_scale) {
                    searchScale = layerSettings.search_scale;
                } else if(typeof(layer.searchScale) != 'undefined') {
                    searchScale = layer.searchScale;
                }
                
                var data = {
                    'defaultField': defaultField,
                    'records': [],
                    'fields': [],
                    'limit': this.limit,
                    'scale': searchScale
                };
                
                //
                for (var i = 0; i < layer.features.length; i++) {
                    if (layer.features[i].attributes[field] == null ||
                        data.records.length >= this.limit) {
                        
                        continue;
                    }
                    if (layer.features[i].attributes[field].toString().toLowerCase().search(fieldValue) != -1) {
                        var featureAttributes = layer.features[i].attributes;
                        if(gt.control.offline.isOnline) {
                            featureAttributes.the_geom = layer.features[i].geometry.toString();
                        } else {
                            featureAttributes.__layerClass = layerSettings['class'];
                            featureAttributes.__featureId = layer.features[i].fid;
                        }
                        
                        if(! searchEverywhere) {
                            if (currentBounds.intersectsBounds(layer.features[i].geometry.bounds)) {
                                data.records.push(featureAttributes);
                            }
                        } else {
                            data.records.push(featureAttributes);
                        }
                    }
                }
                
                //
                for (var key in gt.map.removeReservedAttributes(layer.features[0].attributes)) {
                    data.fields.push(key);
                }
                
                this.set(data);
            }
            
            return false;
        }, this));
        
        $.mobile.hidePageLoadingMsg();
    } ,

    set: function (data) {
    	$('#gtSearchSubmit').button('enable');
    	
        //Clean up DOM
        $("div[data-role='page']").each(function (index, value){
            var el = $(value);
            var page = 'gtSearch&ui-page=';
            if(el.jqmData('url').substr(0, page.length) == page) {
                el.remove();
            }           
        });
        
        //Empty select result
        if(data.records.length == 0) {
            Giscuit.Util.jqmMessage(gt.translate._('emptyResult'));

            return;
        }
        var scale = data.scale;
        var html = '<ul data-role="listview">';

        for(var a = 0; a < data.records.length; a++) {
            var item = data.records[a];
            if(item[data.defaultField]) {
                //Check if default field is a file field
                if (typeof item[data.defaultField] == 'object') {
                    html += '<li>' + item[data.defaultField].value + '<ul>';
                } else {
                    html += '<li>' + item[data.defaultField] + '<ul>';
                }
            } else {
                html += '<li>' + gt.translate._('emptyField') + '<ul>';
            }
            
            var maxLength = (data.fields.length < gt.config.maxFieldsAmount) ? data.fields.length : gt.config.maxFieldsAmount;
            for(var b = 0; b < maxLength; b++) {
                var field = data.fields[b];
                
                //
                if(field == '__layerClass' || field == '__featureId') {
                    continue;
                }
                
                if((typeof(item[field]) != 'object' && typeof(item[field]) != 'function') || 
                    item[field] === null) {
                    
                    if(item[field] === null) {
                        item[field] = '';
                    }

                    html += '<li>' + field + ': ' + item[field] + '</li>';
                    
                } else if(typeof(item[field]) == 'object' && 
                    item[field].type && 
                    (item[field].type == 'image' || item[field].type == 'file')
                    ) {
                    
                    html += '<li><a target="_blank" href="' +
                    item[field].url +
                    '">' +
                    field + ': ' + item[field].value +
                    '</a></li>';
                }
            }
            
            //
            if(typeof(item.the_geom) != 'undefined') {
                var jqmData = 'data-geometry="' + item.the_geom + '"';
            } else if(typeof(item.__layerClass) != 'undefined' && typeof(item.__featureId) != 'undefined') {
                var jqmData = 'data-layer-class="' + item.__layerClass + '" data-feature-id="' + item.__featureId + '"';
            }
            html += '<li ' + jqmData + '><button type="button" class="gtSearchShowOnMapButton" style="z-index: 1100;">' + gt.translate._('showResultsOnMap') + '</button></li>';

            html += '</ul></li>';
        }
        
        html += '</ul>';
        
        //Show column limitation tooltip
        if (maxLength == gt.config.maxFieldsAmount) {
        	var firstNFieldsDisplayed = gt.translate._('firstNFieldsDisplayed').replace("%1$s", gt.config.maxFieldsAmount);
        	Giscuit.Util.jqmMessage(firstNFieldsDisplayed);
        }
            
        //Render
        var content = $("#gtSearch > div[data-role='content']")
            .html(html).trigger('create');
       
        //Initialize map result button
        $('.gtSearchShowOnMapButton').unbind(gt.config.clickEvt).bind(gt.config.clickEvt, this, function(evt) {
            var geometry = $(this.parentNode.parentNode).jqmData('geometry');
            var layerClass = $(this.parentNode.parentNode).jqmData('layer-class');
            var featureId = $(this.parentNode.parentNode).jqmData('feature-id');
                        
            if(typeof(geometry) != 'undefined') {
                var geometry = OpenLayers.Geometry.fromWKT(
                    $(this.parentNode.parentNode).jqmData('geometry')
                );
                
                if(evt.data.selected != null) {
                    gt.layer.vector.destroyFeatures([evt.data.selected]);
                    evt.data.selected = null;
                }
                evt.data.selected = new OpenLayers.Feature.Vector(geometry);
                
                gt.layer.vector.addFeatures([evt.data.selected]);
                gt.map.zoomToExtent(geometry.getBounds());
            } else if (typeof(layerClass) != 'undefined' && typeof(featureId) != 'undefined') {
                var feature = gt.layer[layerClass].getFeatureByFid(featureId);
                
                evt.data.selectControl.unselectAll();
                evt.data.selectControl.select(feature);
                gt.map.zoomToExtent(feature.geometry.getBounds());
            }
            
            //Zoom to scale if available
            if(scale != null) {
                gt.map.zoomToScale(parseInt(scale));
            }
            
            $.mobile.changePage($('#gtMap'), {
                'changeHash': true
            });
            
            return false;
        });

        if (data.records.length == 1) {

            $("div[data-role='page']").each(function (index, value) {
                var el = $(value);
                var page = 'gtSearch&ui-page=';
                if(el.jqmData('url').substr(0, page.length) == page) {
                    $.mobile.changePage('#' + el.jqmData('url'), {
                        'changeHash': true
                    });
                }
            });
            
        } else { 
            $.mobile.changePage($('#gtSearch'), {
                'changeHash': true
            });
        }
        
        $.mobile.hidePageLoadingMsg();
    } ,
    
    getFieldsSuccess: function (data) {
        //Populate select with field options
        var options = $("#gtSearchField");
        
        for (var field in data.fields) {
            options.append($("<option>").val(field).text(field));
        }

        $("#gtSearchField").val(data.defaultField);
        $("#gtSearchField").selectmenu("refresh", true);

        $.mobile.hidePageLoadingMsg();
    } ,
    
    selectTable: function () {
        //Remove current fields and send request for new ones
        $.mobile.showPageLoadingMsg();

        $('#gtSearchField').children().remove();
        
        var layerSettings = gt.control.layers.getLayerRecordById($('#gtSearchLayer').val());
        
        if (gt.control.offline.isOnline && ! layerSettings.js_layer) {
            var url = gt.config.httpToolPath + "/search/fields/layer_id/" + $('#gtSearchLayer').val();
            
            $.ajax({
                'type': 'POST',
                'url': url,
                'success': this.getFieldsSuccess,
                'error': Giscuit.Util.jqmAjaxError ,
                'dataType': 'json' ,
                'context': this
            });
        } else {
            var data = {
                'defaultField': layerSettings.default_field,
                'fields': {}
            };
            
            for (var key in gt.map.removeReservedAttributes(gt.layer[layerSettings['class']].features[0].attributes)) {
                data.fields[key] = gt.translate._(key);
            }
            
            this.getFieldsSuccess(data);
        }
    } ,
    
    buildOfflineForm: function () {
        var layerSettingsArr = gt.control.layers.records;
        var selectedLayer = null;
        var layerType = Giscuit.Util.getStorageObject('gtLayerType');
        
        var form = '<form id="gtSearchForm" enctype="application/x-www-form-urlencoded" method="post" action="">';
            form += '<dl class="zend_form">';
            form += '<dt id="gtSearchLayer-label"><label for="gtSearchLayer" class="required">' + gt.translate._('layer') + '</label></dt>';
                form += '<fieldsset data-role="controlgroup"> <select name="layer" id="gtSearchLayer">';
                    for (var i = 0; i < layerSettingsArr.length; i++) {
                        if (layerSettingsArr[i].offline == true &&
                                layerType['layer_' + layerSettingsArr[i].id] == 'vector') {
                            
                            form += '<option value="' + layerSettingsArr[i].id + '" label="' + layerSettingsArr[i].name + '">' + layerSettingsArr[i].name + '</option>';
                            if (selectedLayer == null) {
                                selectedLayer = layerSettingsArr[i];
                            }
                        }
                    }
                form += '</select></fieldsset>';
            form += '<dt id="gtSearchField-label"><label for="gtSearchField" class="required">' + gt.translate._('field') + '</label></dt>';
                form += '<fieldsset data-role="controlgroup"> <select name="field" id="gtSearchField">';
                    //
                    if(gt.layer[selectedLayer['class']].features.length) {
                        for (var key in gt.map.removeReservedAttributes(gt.layer[selectedLayer['class']].features[0].attributes)) {
                            form += '<option value="' + key + '">' + gt.translate._(key) + '</option>';
                        }
                    }
                form += '</select></fieldsset>';
            form += '<dt id="gtSearchWhere-label"><label for="gtSearchWhere" class="optional">' + gt.translate._('where') + '</label></dt>';
                form += '<fieldsset data-role="controlgroup"> <label for="gtSearchWhere-everywhere">';
                    form += '<input type="radio" name="where" id="gtSearchWhere-everywhere" value="everywhere" checked="checked">' + gt.translate._('everywhere') + '</label>';
                    form += '<label for="gtSearchWhere-bbox"><input type="radio" name="where" id="gtSearchWhere-bbox" value="bbox">' + gt.translate._('withInCurrentBbox') + '</label>';
                form += '</fieldsset>';
            form += '<dt id="gtSearchText-label"><label for="gtSearchText" class="optional">' + gt.translate._('text') + '</label></dt>';
            form += '<dd id="gtSearchText-element"> <input type="text" name="text" id="gtSearchText" value="" onkeypress="return event.keyCode != 13"></dd>';
            form += '<button type="button" name="submit_button" id="gtSearchSubmit">' + gt.translate._('search') + '</button></dl></form>';
            
        return form;
    },
    
    CLASS_NAME: "Giscuit.Mobile.Control.Search"
});
