<?php

class DrawControllerTest extends Giscuit_Test_PHPUnit_ControllerTestCase
{
    protected $_drawParams = array (
        'layers' => 'basic' ,
        'mode' => 'map' ,
        'map_imagetype' => 'png' ,
        'mapext' => '25.89208184375+44.808018105469+30.85790215625+49.120151894531' ,
        'imgext' => '25.89208184375+44.808018105469+30.85790215625+49.120151894531' ,
        'map_size' => '904+785' ,
        'imgx' => 452 ,
        'imgy' => 392.5 ,
        'imgxy' => '904+785'
    );
    
    public function testIndexAction()
    {
        $this->_testLoginActionSuccess();
        
        $queryString = '';
        foreach ($this->_drawParams as $key => $value) {
            $queryString .= "{$key}={$value}&";  
        }
        
        $url = '/' . $this->_language . '/default/draw/index?' . $queryString;        
        $this->dispatch($url);
        
        $response = $this->getResponse()->getBody();
        
        //
        $mapSize = explode('+', $this->_drawParams['map_size']);
        
        //Get image size
        file_put_contents(GT_TMP_PATH . DIR_SEP . 'DrawControllerTest', $response);
        $size = getimagesize(GT_TMP_PATH . DIR_SEP . 'DrawControllerTest');
        unlink(GT_TMP_PATH . DIR_SEP . 'DrawControllerTest');
        
        //Assert size
        $this->assertEquals($size[0], $mapSize[0]);
        $this->assertEquals($size[1], $mapSize[1]);
        
    }
}