<?php

class SnapControllerTest extends Giscuit_Test_PHPUnit_ControllerTestCase
{

    protected $_layerName = 'Worldboundaries';

    protected $_snapParams = array(
        'TYPENAME' => 'giscuit_snap' , 
        'SERVICE' => 'WFS' , 
        'VERSION' => '1.0.0' , 
        'REQUEST' => 'GetFeature' , 
        'WIDTH' => '904' , 
        'HEIGHT' => '785' , 
        'SRS' => 'EPSG%3A4326' , 
        'BBOX' => '28.069405078882,46.975994527363,28.07425451278,46.980205595517'
    );

    protected function _getIdFromClass ($layer)
    {
        $layersTable = new Giscuit_Db_Table_Layers();
        $row = $layersTable->getItems(array(
            'whereClass' => $layer
        ));
        foreach ($row as $r) {
            $id = $r['id'];
        }
        return $id;
    }

    protected function _setSnapAndInfo ()
    {
        //
        $id = $this->_getIdFromClass($this->_layerName);
        
        $this->dispatch('/' . $this->_language . '/tool/privatelayers/edit/id/' . $id . '/column/select/value/true');
        
        $response = $this->getResponse()->getBody();
        $response = Zend_Json::decode($response);
        $this->assertEquals($response['replyCode'], 200);
        
        $this->clear();
        
        //
        $this->request->setMethod('POST')->setPost(array(
            'giscuit_language' => 'en' , 
            'snap' => 't' , 
            'timezone' => 'Europe/Chisinau' , 
            'tooltip' => 't'
        ));
        $this->dispatch('/' . $this->_language . '/default/settings');
        
        $this->clear();
    }

    protected function _unsetSnapAndInfo ()
    {
        //
        $id = $this->_getIdFromClass($this->_layerName);
        
        $this->dispatch('/' . $this->_language . '/tool/privatelayers/edit/id/' . $id . '/column/select/value/false');
        
        $response = $this->getResponse()->getBody();
        $response = Zend_Json::decode($response);
        $this->assertEquals($response['replyCode'], 200);
        
        $this->clear();
        
        //
        $this->request->setMethod('POST')->setPost(array(
            'giscuit_language' => 'en' , 
            'snap' => 'f' , 
            'timezone' => 'Europe/Chisinau' , 
            'tooltip' => 't'
        ));
        $this->dispatch('/' . $this->_language . '/default/settings');

        $this->clear();
    }

    public function testIndexAction ()
    {
        //
        $this->_testLoginActionSuccess();
                
        //
        $this->_setSnapAndInfo();
        
        $queryString = '';
        foreach ($this->_snapParams as $key => $value) {
            $queryString .= "{$key}={$value}&";
        }
        $url = '/' . $this->_language . '/default/snap/index/?' . $queryString;
        $this->dispatch($url);
        
        $response = $this->getResponse()->getBody();
        $this->assertContains('<gml:coordinates>27.820039,48.416270</gml:coordinates>', $response);

        $this->clear();
        
        //
        $this->_unsetSnapAndInfo();
    }
}